﻿// obj file loader Vup to Unity app for editor mode and runtime mode

using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
#if UNITY_EDITOR
using UnityEditor;
#endif


public class OBJLoader
{

static float GSCALE=10;

    public static bool splitByMaterial = true;
    public static string[] searchPaths = new string[] { "", "%FileName%_Textures" + Path.DirectorySeparatorChar };
    //structures
    struct OBJFace
    {
        public string materialName;
        public string meshName;
        public int[] indexes;
    }

[DllImport("pipecomdll.dll")]
    public static extern int openpipeclient(String name);

[DllImport("pipecomdll.dll")]
    public static extern int closepipeclient();

[DllImport("pipecomdll.dll")]
public static extern int writepipeclient(uint len,byte []data);

[DllImport("pipecomdll.dll")]
public static extern int leninpipeclient();

[DllImport("pipecomdll.dll")]
public static extern int readpipeclient(uint minlen,uint maxlen,byte []data);

    //functions
#if UNITY_EDITOR

[DllImport("user32.dll", EntryPoint = "FindWindow")]
public static extern System.IntPtr FindWindow(System.String className, System.String windowName);	
[DllImport("user32.dll")]
public static extern int SendMessage( System.IntPtr hWnd, int wMsg,  System.IntPtr wParam,  System.IntPtr lParam);
     


	[DllImport("vupdll.dll")]
public static extern int vupdll_com(byte[] sbuffer,byte[] buffer);

[DllImport("vupdll.dll")]
public static extern int vupdll_init( System.IntPtr hWnd);

[DllImport("vupdll.dll")]
public static extern int vupdll_uninit();
[DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
static extern ushort GlobalGetAtomName(ushort atom, System.Text.StringBuilder lpString,int size);
[DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
static extern ushort GlobalDeleteAtom(ushort atom);

static System.IntPtr vup_hwnd;

static ArrayList toberefreshmat;

static int vup_vcom_connect(ref int nsp,ref string prpdir)
{
vup_hwnd = FindWindow("vu_communication", null);
if(vup_hwnd==null)
    {
    return -1;
    }
int Z=vupdll_init(vup_hwnd);
if(Z!=1234)
	{
	return -2;
	}
System.IntPtr LPARAM;
LPARAM=(System.IntPtr)1234; 
if(SendMessage(vup_hwnd,0x400/*WM_USER*/+0x1241,System.IntPtr.Zero,LPARAM)!=0x4112)
	{
	vupdll_uninit();
	return -3;
	}
nsp=SendMessage(vup_hwnd,0x400/*WM_USER*/+0x1243,System.IntPtr.Zero,System.IntPtr.Zero);
ushort atom=(ushort)SendMessage(vup_hwnd,0x400/*WM_USER*/+0x1244,System.IntPtr.Zero,System.IntPtr.Zero);
if(atom==0)
	{
	vupdll_uninit();
	return -4;
	}
int nSize = 1024;
StringBuilder AtomName = new System.Text.StringBuilder(nSize);
GlobalGetAtomName(atom,AtomName,nSize);
prpdir=AtomName.ToString();
GlobalDeleteAtom(atom);
return 0;
}

static void vup_vcom_unconnect()
{ 
vupdll_uninit();
}

    [MenuItem("GameObject/Import From VUP")]
    static void VupLoadMenu()
    {
	toberefreshmat=new ArrayList();

	int nsp=0;
	string prpdir="";

	if(vup_vcom_connect(ref nsp,ref prpdir)==0)
		{
		closepipeclient();
		int r=openpipeclient("vupservice");
		int csp;
		GameObject []OBJS;
		OBJS=new GameObject[nsp];
		GameObject []POBJS;
		POBJS=new GameObject[nsp];
		GameObject master;
		master=new GameObject("vup");
		vupobj vom=master.AddComponent<vupobj>();
		vom.num=-1; 
        System.Diagnostics.Stopwatch s = new System.Diagnostics.Stopwatch();
        s.Start();
		for(csp=0;csp<nsp;csp++)
			{
			string info;
			info=csp.ToString()+"/"+nsp.ToString();
			UnityEditor.EditorUtility.DisplayProgressBar("Import from VUP", info,(float)csp/(float)nsp);
			int childof=-1;
			string name="";
			string pth;
			pth=prpdir;
			pth+="\\meshes\\";
            pth+=csp.ToString();
			pth+=".obj";
			GameObject P=new GameObject();
			vupobj vop=P.AddComponent<vupobj>();
			vop.num=csp;
			vop.aorb=0;
             try  
                {  
				int dyntexture=-1;
				int notselectable=0;
				uint gid1=0,gid2=0;
				double scx=1,scy=1,scz=1;
				GameObject O=LoadOBJFile(pth,ref childof,ref name,ref dyntexture,ref notselectable,ref gid1,ref gid2,ref scx,ref scy,ref scz);
				vupobj vo=O.AddComponent<vupobj>();
				vo.num=csp;
				vo.aorb=1;
				vo.dyntex=dyntexture;
				vo.gd1=gid1;
				vo.gd2=gid2;
				string id="(vup#";
				id+=csp.ToString()+")";
				name=id+name;
				OBJS[csp]=O;
				POBJS[csp]=P;
				if(childof==-1)
					{ 
					P.transform.SetParent(master.transform);
					}
				else
					{
					P.transform.SetParent(OBJS[childof].transform);
					}	
				O.name=name+".b";
				O.transform.SetParent(P.transform);
				P.name=name+".a";
				}
			catch (System.Exception e)
				{
				string txt="Error while importing file, please export first from Vup with the menu File/Generate/For Unity. ";
				txt+=e.Message.ToString();
				UnityEditor.EditorUtility.DisplayDialog("Import from Vup",txt,"Ok");
				UnityEditor.EditorUtility.ClearProgressBar();
				return;
                }
			}
	
	System.Threading.Thread.Sleep(1000);
	if(vup_hwnd!=System.IntPtr.Zero)
		{ 
		byte [] buffer; 
		buffer=new byte[0x800000];
		byte [] sbuffer; 
		sbuffer=new byte[0x1000];
		int clicked=-1;
		int picked=-1;
		int spos=0;
		
		byte[] b = BitConverter.GetBytes(clicked);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(picked);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		int CC;
		for(CC=0;CC<10;CC++)
		{ 
		int len=vupdll_com(sbuffer,buffer);
		if(len>0)
			{
			int pos=0;
			int slen=BitConverter.ToInt32(buffer,pos+4);

			uint nchangedsprite3d=BitConverter.ToUInt32(buffer,pos+12);
			uint c;
			pos+=slen-4;
			for(c=0;c<nchangedsprite3d;c++)
				{
				int slen2=BitConverter.ToInt32(buffer,pos);
				int pos2=pos+4;
				uint num=BitConverter.ToUInt32(buffer,pos2);
				pos2+=4;
				uint obj=num&0x7fffffff;
				bool tchanged=false,rchanged=false,schanged=false;
				float x=0,y=0,z=0;
				float rx=0,ry=0,rz=0;
				float qx=0,qy=0,qz=0,qw=0;
				float arx=0,ary=0,arz=0;
				float sx=1,sy=1,sz=0;
				Int16 visible=0;
				Int16 selectable=0;
				Int16 pickable=0;
				Int16 usetextmat=0;
				float texoffsetx=0;
				float texoffsety=0;
				float []metal;
				float []roughness;
				float []alpha;
				metal=new float[128];
				roughness=new float[128];
				alpha=new float[128];
				Int32 childof=-1;
				if((num&0x80000000)!=0) 
					{
					ushort changed1=BitConverter.ToUInt16(buffer,pos2);
					if((changed1&1)!=0)
						{ 
						tchanged=true;
						x=-BitConverter.ToSingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&2)!=0)
						{ 
						tchanged=true;
						y=BitConverter.ToSingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&4)!=0)
						{ 
						tchanged=true;
						z=BitConverter.ToSingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&8)!=0)
						{ 
						rchanged=true;
						rx=BitConverter.ToSingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&0x10)!=0)
						{ 
						rchanged=true;
						ry=BitConverter.ToSingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&0x20)!=0)
						{ 
						rchanged=true;
						rz=-BitConverter.ToSingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&0x40)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x80)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x100)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x200)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x400)!=0)
						{
						pos2+=2;
						}
					if((changed1&0x800)!=0)
						{
						pos2+=2;
						}
					if((changed1&0x1000)!=0)
						{
						pos2+=2;
						}
					if((changed1&0x2000)!=0)
						{
						ushort um=BitConverter.ToUInt16(buffer,pos2);
						pos2+=2;
						if(um!=0)
							{
							pos2+=8;
							}
						}
					if((changed1&0x4000)!=0)
						{
						schanged=true;
						sx=tosingle(buffer,pos2);
						pos2+=4;
						sy=tosingle(buffer,pos2);
						pos2+=4;
						sz=tosingle(buffer,pos2);
						pos2+=4;
						}
					}
				else
					{
					tchanged=true;
					rchanged=true;
					x=-BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					y=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					z=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					rx=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					ry=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					rz-=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					qx=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					qy=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					qz-=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					qw-=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					arx=-BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					ary=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					arz=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					if(slen2>=2140) // Structure incluant l'échelle
						{
						schanged=true;
						sx=tosingle(buffer,pos2);
						pos2+=4;
						sy=tosingle(buffer,pos2);
						pos2+=4;
						sz=tosingle(buffer,pos2);
						pos2+=4;
						}
					childof=BitConverter.ToInt32(buffer,pos2);
					pos2+=4;
					visible=BitConverter.ToInt16(buffer,pos2);
					pos2+=2;
					selectable=BitConverter.ToInt16(buffer,pos2);
					pos2+=2;
					pickable=BitConverter.ToInt16(buffer,pos2);
					pos2+=2;
					// metalness
					int cm;
					for(cm=0;cm<128;cm++)
						{
						metal[cm]=BitConverter.ToSingle(buffer,pos2); 
						pos2+=4;
						}
					// roughness
					for(cm=0;cm<128;cm++)
						{
						roughness[cm]=BitConverter.ToSingle(buffer,pos2); 
						pos2+=4;
						}
					// alpha
					for(cm=0;cm<128;cm++)
						{
						alpha[cm]=BitConverter.ToSingle(buffer,pos2); 
						pos2+=4;
						}
					// col
					pos2+=128*4;
					usetextmat=BitConverter.ToInt16(buffer,pos2);
					pos2+=2;
					texoffsetx=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					texoffsety=BitConverter.ToSingle(buffer,pos2);
					pos2+=4;
					pos+=slen2;
					}
				if(obj<OBJS.Length&&OBJS[obj]!=null) 
					{ 

					if((visible&1)!=0)
						{ 
						MeshRenderer R=OBJS[obj].GetComponentInChildren<MeshRenderer>();
						R.enabled=true;
						}
					else
						{ 
						MeshRenderer R=OBJS[obj].GetComponentInChildren<MeshRenderer>();
						R.enabled=false;
						}
					if(usetextmat!=0)
						{
						MeshRenderer R=OBJS[obj].GetComponentInChildren<MeshRenderer>();
						R.material.SetTextureOffset("_MainTex", new Vector2(texoffsetx,texoffsety));
						}
					if(schanged)
						{
						Vector3 curscale=OBJS[obj].transform.localScale;
						if(curscale.x!=sx||curscale.y!=sy||curscale.z!=sz)
							{
							OBJS[obj].transform.localScale=new Vector3(sx,sy,sz);
							}
						}
					if(tchanged||rchanged) 
						{ 
						Quaternion Q=new Quaternion(qx,qy,-qz,qw);
						POBJS[obj].transform.localRotation=Q;
						POBJS[obj].transform.localPosition=new Vector3(x/GSCALE,y/GSCALE,z/GSCALE);
						OBJS[obj].transform.localPosition=new Vector3(arx/GSCALE,ary/GSCALE,arz/GSCALE);
						}
					}
				}

			}
			}
		UnityEditor.EditorUtility.ClearProgressBar();
        s.Stop();
		vup_vcom_unconnect();
		
	
		int C,L=toberefreshmat.Count;
		for(C=0;C<L;C++)
			{ 
			UnityEditor.Selection.activeObject=(UnityEngine.Object)toberefreshmat[C];
			System.Threading.Thread.Sleep(1000);
			}
		
		}
	else
		{
		UnityEditor.EditorUtility.DisplayDialog("Import Vup","Can't connect, please launch VUP, open projet, and generate player view first","Ok");
		}
	}
	}
#endif

    public static Vector3 ParseVectorFromCMPS(string[] cmps)
    {
        float x = float.Parse(cmps[1]);
        float y = float.Parse(cmps[2]);
        if (cmps.Length == 4)
        {
            float z = float.Parse(cmps[3]);
            return new Vector3(x, y, z);
        }
        return new Vector2(x, y);
    }
    public static Color ParseColorFromCMPS(string[] cmps,float scalar = 1.0f)
    {
        float Kr = float.Parse(cmps[1]) * scalar ;
        float Kg = float.Parse(cmps[2]) * scalar;
        float Kb = float.Parse(cmps[3]) * scalar;
        return new Color(Kr, Kg, Kb);
    }

    public static string OBJGetFilePath(string path, string basePath, string fileName)
    {
        foreach (string sp in searchPaths)
        {
            string s = sp.Replace("%FileName%", fileName);
            if (File.Exists(basePath + s + path))
            {
                return basePath + s + path;
            }
            else if (File.Exists(path))
            {
                return path;
            }
        }

        return null;
    }
    public static Material[] LoadMTLFile(string fn,ref int dyntex,int transparenttexture)
    {
        Material currentMaterial = null;
        List<Material> matlList = new List<Material>();
        FileInfo mtlFileInfo = new FileInfo(fn);
        string baseFileName = Path.GetFileNameWithoutExtension(fn);
        string mtlFileDirectory = mtlFileInfo.Directory.FullName + Path.DirectorySeparatorChar;
        foreach (string ln in File.ReadAllLines(fn))
        {
            string l = ln.Trim().Replace("  ", " ");
            string[] cmps = l.Split(' ');
            string data = l.Remove(0, l.IndexOf(' ') + 1);
	
			if (cmps[0] == "newmtl")
            {
                if (currentMaterial != null)
                {
				string mn=currentMaterial.ToString();
                    matlList.Add(currentMaterial);
                }
                currentMaterial = new Material(Shader.Find("Standard (Specular setup)"));
			

                currentMaterial.name = data;
            }
            else if (cmps[0] == "Kd")
            {
			float A=currentMaterial.GetColor("_Color").a;
			float R=currentMaterial.GetColor("_Color").r;
			float G=currentMaterial.GetColor("_Color").g;
			float B=currentMaterial.GetColor("_Color").b;
			Color C=ParseColorFromCMPS(cmps);

            currentMaterial.SetColor("_Color",new Color((R+C.r)/2,(G+C.g)/2,(B+C.b)/2,(A+C.a)/2));
            }
            else if (cmps[0] == "map_Kd")
            {
                //TEXTURE
                string fpth = OBJGetFilePath(data, mtlFileDirectory,baseFileName);


                if (fpth != null)
					{ 
					Texture2D t2d;
					t2d=TextureLoader.LoadTexture(fpth);
					if(transparenttexture!=0)
						{ 
					
						currentMaterial.SetFloat("_Mode", 3);
						currentMaterial.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.SrcAlpha);
						currentMaterial.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);
						currentMaterial.SetInt("_ZWrite", 0);
						currentMaterial.DisableKeyword("_ALPHATEST_ON");
						currentMaterial.EnableKeyword("_ALPHABLEND_ON");
						currentMaterial.DisableKeyword("_ALPHAPREMULTIPLY_ON");
						currentMaterial.SetFloat("_Glossiness",0);
						currentMaterial.renderQueue = 3000;
 						
						}
                    currentMaterial.SetTexture("_MainTex",t2d);
				
					if(data[0]=='s')
						{
						if(data[1]>='0'&&data[1]<='9')
							{
							int pos1=data.IndexOf('(');
							int pos2=data.IndexOf(')');
							if(pos1>=0&&pos2>pos1)
								{
								string S=data.Substring(pos1+1,pos2-pos1-1);
								try
								{ 
								dyntex=int.Parse(S);
								}
#pragma warning disable CS0168 // The variable 'E' is declared but never used
								catch(Exception E)
#pragma warning restore CS0168 // The variable 'E' is declared but never used
								{

								}
								}
							}
						}
					}
            }
            else if (cmps[0] == "map_Bump")
            {
                //TEXTURE
                string fpth = OBJGetFilePath(data, mtlFileDirectory,baseFileName);
                if (fpth != null)
                {
                    currentMaterial.SetTexture("_BumpMap", TextureLoader.LoadTexture(fpth, true));
                    currentMaterial.EnableKeyword("_NORMALMAP");
                }
            }
            else if (cmps[0] == "Ks")
            {
                currentMaterial.SetColor("_SpecColor", ParseColorFromCMPS(cmps));
            }
            else if (cmps[0] == "Ka")
            {
			 currentMaterial.SetColor("_Color",ParseColorFromCMPS(cmps));

            }
            else if (cmps[0] == "d")
            {
                float visibility=1;
				try
				{
				visibility= float.Parse(cmps[1]);
				}
#pragma warning disable CS0168 // The variable 'E' is declared but never used
				catch(Exception E)
#pragma warning restore CS0168 // The variable 'E' is declared but never used
				{

				}
                if (visibility < 1)
                {
                    Color temp = currentMaterial.color;

                    temp.a = visibility;
                    currentMaterial.SetColor("_Color", temp);

                    currentMaterial.SetFloat("_Mode", 3);
                    currentMaterial.SetInt("_SrcBlend", (int)UnityEngine.Rendering.BlendMode.SrcAlpha);
                    currentMaterial.SetInt("_DstBlend", (int)UnityEngine.Rendering.BlendMode.OneMinusSrcAlpha);
                    currentMaterial.SetInt("_ZWrite", 0);
                    currentMaterial.DisableKeyword("_ALPHATEST_ON");
                    currentMaterial.EnableKeyword("_ALPHABLEND_ON");
                    currentMaterial.DisableKeyword("_ALPHAPREMULTIPLY_ON");
                    currentMaterial.renderQueue = 3000;
                }

            }
            else if (cmps[0] == "Ns")
            {
                float Ns =0;
				try
				{
			    Ns=float.Parse(cmps[1]);
				}
#pragma warning disable CS0168 // The variable 'E' is declared but never used
				catch(Exception E)
#pragma warning restore CS0168 // The variable 'E' is declared but never used
				{

				}
                Ns = (Ns / 1000);
                currentMaterial.SetFloat("_Glossiness", Ns);

            }
            else if (cmps[0] == "Pm")
            {
                float Pm = float.Parse(cmps[1])/2; 
				if(Pm>1) Pm=1;
				if(Pm<0) Pm=0;
                currentMaterial.SetFloat("_Metallic", Pm);

            }
            else if (cmps[0] == "Pr")
            {
			 float Pr=0;
			try
			{
               Pr = float.Parse(cmps[1]);
			   }
#pragma warning disable CS0168 // The variable 'E' is declared but never used
			   catch(Exception E)
#pragma warning restore CS0168 // The variable 'E' is declared but never used
			   {

			   }
				if(Pr>1) Pr=1;
				if(Pr<0) Pr=0;
                currentMaterial.SetFloat("_Glossiness", 1-Pr);

            }
        
		}
        if(currentMaterial != null)
        {

	
            matlList.Add(currentMaterial);

        }
        return matlList.ToArray();
    }

	public static unsafe float tosingle(byte[] numRef, int startIndex)
	{
    var val = (uint)((numRef[startIndex+3] << 0x18) | (numRef[startIndex+2] << 0x10) | (numRef[startIndex+1] << 0x8) | numRef[startIndex+0]);
	return *(float*)&val;
	}
	public static unsafe uint touint32(byte[] numRef, int startIndex)
	{
    var num = (uint)((numRef[startIndex+3] << 0x18) | (numRef[startIndex+2] << 0x10) | (numRef[startIndex+1] << 0x8) | numRef[startIndex]);
    return (uint)num;
	}

    public static GameObject LoadOBJFile(string fn,ref int childof,ref string name,ref int dyntex,ref int notselectable,ref uint gid1,ref uint gid2,ref double scx,ref double scy, ref double scz)
    {
	name="";
	childof=-1;
        string meshName = Path.GetFileNameWithoutExtension(fn);

		int drawbothfaces=0;

		int transparenttexture=0;
        bool hasNormals = false;
        //OBJ LISTS
        List<Vector3> vertices = new List<Vector3>();
        List<Vector3> normals = new List<Vector3>();
        List<Vector2> uvs = new List<Vector2>();
        //UMESH LISTS
        List<Vector3> uvertices = new List<Vector3>();
        List<Vector3> unormals = new List<Vector3>();
        List<Vector2> uuvs = new List<Vector2>();
        //MESH CONSTRUCTION
        List<string> materialNames = new List<string>();
        List<string> objectNames = new List<string>();
        Dictionary<string,int> hashtable = new Dictionary<string, int>();
		int HC=0;
        List<OBJFace> faceList = new List<OBJFace>();
        string cmaterial = "";
        string cmesh = "default";
        //CACHE
        Material[] materialCache = null;
        //save this info for later
        FileInfo OBJFileInfo = new FileInfo(fn);
         
        foreach (string ln in File.ReadAllLines(fn))
        {
            if (ln.Length > 2 && ln[0] == '#'&& ln[1] == 'N'&& ln[2] == 'S')
				{
				notselectable=1;
				}
            if (ln.Length > 2 && ln[0] == '#'&& ln[1] == 'B'&& ln[2] == 'F')
				{
				drawbothfaces=1;
				}
            if (ln.Length > 2 && ln[0] == '#'&& ln[1] == 'T'&& ln[2] == 'T')
				{
				transparenttexture=1;
				}
          if (ln.Length > 2 && ln[0] == '#'&& ln[1] == 'G'&& ln[2] == '1')
				{
				string l = ln.Trim().Replace("  "," ");
                string[] cmps = l.Split(' ');
				gid1=UInt32.Parse(cmps[1]);
				}
          if (ln.Length > 2 && ln[0] == '#'&& ln[1] == 'G'&& ln[2] == '2')
				{
				string l = ln.Trim().Replace("  "," ");
                string[] cmps = l.Split(' ');
				gid2=UInt32.Parse(cmps[1]);
				}
          if (ln.Length > 7 && ln[0] == '#'&& ln[1] == 'C'&& ln[2] == 'H'&& ln[3] == 'I'&& ln[4] == 'L'&& ln[5] == 'D'&& ln[6] == 'O'&& ln[7] == 'F')
				{
				string l = ln.Trim().Replace("  "," ");
                string[] cmps = l.Split(' ');
				childof=Int32.Parse(cmps[1]);
				}
          if (ln.Length > 5 && ln[0] == '#'&& ln[1] == 'S'&& ln[2] == 'C'&& ln[3] == 'A'&& ln[4] == 'L'&& ln[5] == 'E')
				{
				string l = ln.Trim().Replace("  "," ");
                string[] cmps = l.Split(' ');
				scx=double.Parse(cmps[1]);
				scy=double.Parse(cmps[2]);
				scz=double.Parse(cmps[3]);
				if(scx==0) scx=1;
				if(scy==0) scy=1;
				if(scz==0) scz=1;
				}
            if (ln.Length > 6 && ln[0] == '#'&& ln[1] == 'N'&& ln[2] == 'A'&& ln[3] == 'M'&& ln[4] == 'E'&& ln[5] == ' ')
				{
				string l = ln.Trim().Replace("  "," ");
                string[] cmps = l.Split(' ');
				name=cmps[1];
				}

            if (ln.Length > 0 && ln[0] != '#')
            {
                string l = ln.Trim().Replace("  "," ");
                string[] cmps = l.Split(' ');
                string data = l.Remove(0, l.IndexOf(' ') + 1);

                if (cmps[0] == "mtllib")
                {
                    //load cache
                    string pth = OBJGetFilePath(data, OBJFileInfo.Directory.FullName + Path.DirectorySeparatorChar, meshName);
                    if (pth != null)
                        materialCache = LoadMTLFile(pth,ref dyntex,transparenttexture);

                }
                else if ((cmps[0] == "g" || cmps[0] == "o") && splitByMaterial == false)
                {
                    cmesh = data;
                    if (!objectNames.Contains(cmesh))
                    {
                        objectNames.Add(cmesh);
                    }
                }
                else if (cmps[0] == "usemtl")
                {
                    cmaterial = data;
                    if (!materialNames.Contains(cmaterial))
                    {
                        materialNames.Add(cmaterial);
                    }

                    if (splitByMaterial)
                    {
                        if (!objectNames.Contains(cmaterial))
                        {
                            objectNames.Add(cmaterial);
                        }
                    }
                }
                else if (cmps[0] == "v")
                {
                    //VERTEX
                    vertices.Add(ParseVectorFromCMPS(cmps));

                }
                else if (cmps[0] == "vn")
                {
                    //VERTEX NORMAL
                    normals.Add(ParseVectorFromCMPS(cmps));
                }
                else if (cmps[0] == "vt")
                {
                    //VERTEX UV
					Vector2 v2=ParseVectorFromCMPS(cmps);
					if(dyntex!=-1)
						{
						v2.y=-v2.y;
						}
                    uvs.Add(v2);
                }
                else if (cmps[0] == "f")
                {
                    int[] indexes = new int[cmps.Length - 1];
                    for (int i = 1; i < cmps.Length ; i++)
                    {
                        string felement = cmps[i];
                        int vertexIndex = -1;
                        int normalIndex = -1;
                        int uvIndex = -1;
                        if (felement.Contains("//"))
                        {
                            //doubleslash, no UVS.
                            string[] elementComps = felement.Split('/');
                            vertexIndex = int.Parse(elementComps[0]) - 1;
                            normalIndex = int.Parse(elementComps[2]) - 1;
                        }
                        else if (felement.Count(x => x == '/') == 2)
                        {
                            //contains everything
                            string[] elementComps = felement.Split('/');
                            vertexIndex = int.Parse(elementComps[0]) - 1;
                            uvIndex = int.Parse(elementComps[1]) - 1;
                            normalIndex = int.Parse(elementComps[2]) - 1;
                        }
                        else if (!felement.Contains("/"))
                        {
                            //just vertex inedx
                            vertexIndex = int.Parse(felement) - 1;
                        }
                        else
                        {
                            //vertex and uv
                            string[] elementComps = felement.Split('/');
                            vertexIndex = int.Parse(elementComps[0]) - 1;
                            uvIndex = int.Parse(elementComps[1]) - 1;
                        }
                        string hashEntry = vertexIndex + "|" + normalIndex + "|" +uvIndex;
                        if (hashtable.ContainsKey(hashEntry))
                        {
                            indexes[i - 1] = hashtable[hashEntry];
                        }
                        else
                        {
                            //create a new hash entry
                            indexes[i - 1] = hashtable.Count;
                            hashtable[hashEntry] = hashtable.Count;
                            uvertices.Add(vertices[vertexIndex]);
                            if (normalIndex < 0 || (normalIndex > (normals.Count - 1)))
                            {
                                unormals.Add(Vector3.zero);
                            }
                            else
                            {
                                hasNormals = true;
                                unormals.Add(normals[normalIndex]);
                            }
                            if (uvIndex < 0 || (uvIndex > (uvs.Count - 1)))
                            {
                                uuvs.Add(Vector2.zero);
                            }
                            else
                            {
                                uuvs.Add(uvs[uvIndex]);
                            }

                        }
                    }
                    if (indexes.Length < 5 && indexes.Length >= 3)
                    {
                        OBJFace f1 = new OBJFace();
                        f1.materialName = cmaterial;
                        f1.indexes = new int[] { indexes[0], indexes[1], indexes[2] };
                        f1.meshName = (splitByMaterial) ? cmaterial : cmesh;
                        faceList.Add(f1);
                        if (indexes.Length > 3)
                        {

                            OBJFace f2 = new OBJFace();
                            f2.materialName = cmaterial;
                            f2.meshName = (splitByMaterial) ? cmaterial : cmesh;
                            f2.indexes = new int[] { indexes[2], indexes[3], indexes[0] };
                            faceList.Add(f2);
                        }
                    }
                }
				else
					{
					if(cmps[0]=="$v")
						{ 
						uint cmd=1; // request vertexes
						uint s,i,_l;
						s=uint.Parse(cmps[1]);
						i=uint.Parse(cmps[2]);
						_l=uint.Parse(cmps[3]);
						byte []b=new byte[16];
						byte []b2=BitConverter.GetBytes(cmd);
						b2.CopyTo(b, 0);
						b2=BitConverter.GetBytes(s);
						b2.CopyTo(b, 4);
						b2=BitConverter.GetBytes(i);
						b2.CopyTo(b, 8);
						b2=BitConverter.GetBytes(_l);
						b2.CopyTo(b, 12);
						if(writepipeclient(16,b)>=0)
							{
							int T=System.Environment.TickCount;
							bool timeout=false;
							while(leninpipeclient()<4)
								{
								if(System.Environment.TickCount-T>1000)
									{ 
									timeout=true;
									break;
									}	
								}
							if(timeout)
								{
								Debug.Log("timeout1");
								}
							else
								{ 
								byte []rb=new byte[4];
								if(readpipeclient(4,4,rb)>=0)
									{
									UInt32 R=BitConverter.ToUInt32(rb,0);;
									T=System.Environment.TickCount;
									timeout=false;
									while(leninpipeclient()<_l*36)
										{
										if(System.Environment.TickCount-T>1000)
											{ 
											timeout=true;
											break;
											}	
										}
									if(timeout)
										{
										Debug.Log("timeout2");
										}
									else
										{ 
										byte []rv=new byte[_l*36];
										if(readpipeclient(_l*36,_l*36,rv)>=0)
											{
											int cc;
											for(cc=0;cc<_l;cc++)
												{
												Vector3 v3=new Vector3(tosingle(rv,cc*36)*(float)-0.1,tosingle(rv,4+cc*36)*(float)0.1,tosingle(rv,8+cc*36)*(float)0.1);
												vertices.Add(v3);
												v3=new Vector3(tosingle(rv,12+cc*36),tosingle(rv,16+cc*36),tosingle(rv,20+cc*36));
												normals.Add(v3);
												Vector2 v2= new Vector2(tosingle(rv,28+cc*36),tosingle(rv,32+cc*36));
												if(dyntex==-1)
													{
													v2.y=-v2.y;
													}
												uvs.Add(v2);
												}
											}
										}
									}
								}
							}
						}
					else
						{
						if(cmps[0]=="$i")
							{ 
							uint cmd=2; // request indices
							uint s,_i,_l;
							s=uint.Parse(cmps[1]);
							_i=uint.Parse(cmps[2]);
							_l=uint.Parse(cmps[3]);
							byte []b=new byte[16];
							byte []b2=BitConverter.GetBytes(cmd);
							b2.CopyTo(b, 0);
							b2=BitConverter.GetBytes(s);
							b2.CopyTo(b, 4);
							b2=BitConverter.GetBytes(_i);
							b2.CopyTo(b, 8);
							b2=BitConverter.GetBytes(_l);
							b2.CopyTo(b, 12);
							if(writepipeclient(16,b)>=0)
								{
								int T=System.Environment.TickCount;
								bool timeout=false;
								while(leninpipeclient()<4)
									{
									if(System.Environment.TickCount-T>1000)
										{ 
										timeout=true;
										break;
										}	
									}
								if(timeout)
									{
									Debug.Log("timeout3");
									}
								else
									{ 
									byte []rb=new byte[4];
									if(readpipeclient(4,4,rb)>=0)
										{
										Int32 R=BitConverter.ToInt32(rb,0);;
										T=System.Environment.TickCount;
										timeout=false;
										while(leninpipeclient()<_l*4)
											{
											if(System.Environment.TickCount-T>1000)
												{ 
												timeout=true;
												break;
												}	
											}
										if(timeout)
											{

											Debug.Log("timeout4:"+R.ToString()+" "+s.ToString()+" "+_i.ToString()+" "+l.ToString()+" "+leninpipeclient().ToString());
											}
										else
											{ 
											byte []rv=new byte[_l*4];
											if(readpipeclient(_l*4,_l*4,rv)>=0)
												{
												int cc;
												UInt32 i0,i1,i2;
												for(cc=0;cc<_l;cc+=3)
													{
													i0=touint32(rv,cc*4);
													i1=touint32(rv,4+cc*4);
													i2=touint32(rv,8+cc*4);


                    int[] indexes = new int[3];
                    for (int i = 1; i < 4 ; i++)
                    {
                       
                        int vertexIndex = -1;
                        int normalIndex = -1;
                        int uvIndex = -1;
						if(i==1)
							{
							vertexIndex=(int)i0-1;
							normalIndex=(int)i0-1;
							uvIndex=(int)i0-1;
							}
						else
							{
							if(i==2)
								{
								vertexIndex=(int)i1-1;
								normalIndex=(int)i1-1;
								uvIndex=(int)i1-1;
								}
							else
								{
								vertexIndex=(int)i2-1;
								normalIndex=(int)i2-1;
								uvIndex=(int)i2-1;
								}
							}
  
                        {
                            //create a new hash entry
                            indexes[i - 1] = HC++;

							try
								{ 
								uvertices.Add(vertices[vertexIndex]);
								}
#pragma warning disable CS0168 // The variable 'E' is declared but never used
							catch (Exception E)
#pragma warning restore CS0168 // The variable 'E' is declared but never used
							{

							}

                            if (normalIndex < 0 || (normalIndex > (normals.Count - 1)))
                            {
                                unormals.Add(Vector3.zero);
                            }
                            else
                            {
                                hasNormals = true;
                                unormals.Add(normals[normalIndex]);
                            }
                            if (uvIndex < 0 || (uvIndex > (uvs.Count - 1)))
                            {
                                uuvs.Add(Vector2.zero);
                            }
                            else
                            {
                                uuvs.Add(uvs[uvIndex]);
                            }

                        }
                    }
                    if (indexes.Length < 5 && indexes.Length >= 3)
                    {
                        OBJFace f1 = new OBJFace();
                        f1.materialName = cmaterial;
                        f1.indexes = new int[] { indexes[0], indexes[1], indexes[2] };
                        f1.meshName = (splitByMaterial) ? cmaterial : cmesh;
                        faceList.Add(f1);
                        if (indexes.Length > 3)
                        {

                            OBJFace f2 = new OBJFace();
                            f2.materialName = cmaterial;
                            f2.meshName = (splitByMaterial) ? cmaterial : cmesh;
                            f2.indexes = new int[] { indexes[2], indexes[3], indexes[0] };
                            faceList.Add(f2);
                        }
                    }


													}
												}
											}
										}
									}
								}
							}

						}
					}
            }
        }

        if (objectNames.Count == 0)
            objectNames.Add("default");
       
        //build objects
        GameObject parentObject = new GameObject(meshName);
        parentObject.layer=notselectable==0?8:9;
        
        foreach (string obj in objectNames)
        {
            GameObject subObject = new GameObject(obj);
	        subObject.layer=notselectable==0?8:9;
            subObject.transform.parent = parentObject.transform;
            subObject.transform.localScale = new Vector3(-1, 1, 1);
            //Create mesh
            Mesh m = new Mesh();
            m.name = obj;
            //LISTS FOR REORDERING
            List<Vector3> processedVertices = new List<Vector3>();
            List<Vector3> processedNormals = new List<Vector3>();
            List<Vector2> processedUVs = new List<Vector2>();
            List<int[]> processedIndexes = new List<int[]>();
            Dictionary<int,int> remapTable = new Dictionary<int, int>();
            //POPULATE MESH
            List<string> meshMaterialNames = new List<string>();

            OBJFace[] ofaces = faceList.Where(x =>  x.meshName == obj).ToArray();
            foreach (string mn in materialNames)
            {
                OBJFace[] faces = ofaces.Where(x => x.materialName == mn).ToArray();
                if (faces.Length > 0)
                {
                    int[] indexes = new int[0];
                    foreach (OBJFace f in faces)
                    {
                        int l = indexes.Length;
                        System.Array.Resize(ref indexes, l + f.indexes.Length);
                        System.Array.Copy(f.indexes, 0, indexes, l, f.indexes.Length);
                    }
                    meshMaterialNames.Add(mn);
                    if (m.subMeshCount != meshMaterialNames.Count)
                        m.subMeshCount = meshMaterialNames.Count;

                    for (int i = 0; i < indexes.Length; i++)
                    {
                        int idx = indexes[i];
                        //build remap table
                        if (remapTable.ContainsKey(idx))
                        {
                            
                            indexes[i] = remapTable[idx];
                        }
                        else
                        {
                            processedVertices.Add(uvertices[idx]);
                            processedNormals.Add(unormals[idx]);
                            processedUVs.Add(uuvs[idx]);
                            remapTable[idx] = processedVertices.Count - 1;
                            indexes[i] = remapTable[idx];
                        }
                    }

                    processedIndexes.Add(indexes);
                }
                else
                {

                }
            }

            //apply stuff
            m.vertices = processedVertices.ToArray();
            m.normals = processedNormals.ToArray();
            m.uv = processedUVs.ToArray();

            for (int i = 0; i < processedIndexes.Count; i++)
            {
                m.SetTriangles(processedIndexes[i],i);   
            }

            if (!hasNormals)
            {
             m.RecalculateNormals();   
            }
            m.RecalculateBounds();
            ;

            MeshFilter mf = subObject.AddComponent<MeshFilter>();
            MeshRenderer mr = subObject.AddComponent<MeshRenderer>();

            Material[] processedMaterials = new Material[meshMaterialNames.Count];
            for(int i=0 ; i < meshMaterialNames.Count; i++)
            {
                
                if (materialCache == null)
                {
                    processedMaterials[i] = new Material(Shader.Find("Standard (Specular setup)"));
                }
                else
                {
                    Material mfn = Array.Find(materialCache, x => x.name == meshMaterialNames[i]); ;
                    if (mfn == null)
                    {
                        processedMaterials[i] = new Material(Shader.Find("Standard (Specular setup)"));
                    }
                    else
                    {
                        processedMaterials[i] = mfn;
                    }
                    
                }
                processedMaterials[i].name = meshMaterialNames[i];
            }

            mr.materials = processedMaterials;
            mf.mesh = m;

        }

        return parentObject;
        }
    }
