﻿// Virtual Universe Pro plugin
// 2/8/2018
// in the following, vup means "Virtual Universe Pro"
// (c) Irai


using System.Collections;
using UnityEngine;
using System.Runtime.InteropServices;
using System.Text;
using System;




public class Vup : MonoBehaviour {


[DllImport("user32.dll", EntryPoint = "FindWindow")]
public static extern System.IntPtr FindWindow(System.String className, System.String windowName);	
[DllImport("user32.dll")]
public static extern int SendMessage( System.IntPtr hWnd, int wMsg,  System.IntPtr wParam,  System.IntPtr lParam);
     
[DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
static extern ushort GlobalGetAtomName(ushort atom, System.Text.StringBuilder lpString,int size);
[DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Auto)]
static extern ushort GlobalDeleteAtom(ushort atom);
[DllImport("user32.dll")]
public static extern int PostMessage( System.IntPtr hWnd, int wMsg,  System.IntPtr wParam,  System.IntPtr lParam);
[DllImport("vupdll.dll")]
public static extern int vupdll_init( System.IntPtr hWnd);

[DllImport("vupdll.dll")]
public static extern int vupdll_uninit();
 
[DllImport("vupdll.dll")]
public static extern int vupdll_com(byte[] sbuffer,byte[] buffer);


[DllImport("vupdll.dll")]
public static extern int vupdll_requestsurface(uint surface);

[DllImport("vupdll.dll")]
public static extern int vupdll_getsurface(uint surface,IntPtr buffer);


// vr or not
int vr=0;
// mouse management, sent from Unity app to vup 
public int mouseover=-1; // vup mouse over object number or -1 (no mouse over object)
public int clicked=-1; // vup clicked object number or -1 (no object clicked)
public int picked=-1; // vup picked object number or -1 5no picked object)1
float [] pickedforce; // picked force values
Vector3 firstpickedpos;
Vector3 firstpickedobjpos;
float firstpickeddistance;
int prepicked=-1;
Vector3 prepickedpos;
public Vector3 RayP0,RayP1;
private Vector3 P0,P1;


// vr magagement, sent from Unity App to vup
/* delete this line to use SteamVr
public SteamVR_TrackedObject xrhead;
public SteamVR_TrackedController xrstc1;
public SteamVR_TrackedController xrstc2;
private SteamVR_Controller.Device xrc1;
private SteamVR_Controller.Device xrc2;
private SteamVR_Controller.Device xrch;
 delete this line to use SteamVr */
float [] htcposh;
float [] htcvelh;
float [] htcpos1;
float [] htcpos2;
float [] htcvel1;
float [] htcvel2;
public ulong htcbutton1=0;
public ulong htcbutton2=0;
public float htctrigger1=0;
public float htctrigger2=0;
public Int16 htcisvalid1=0;
public Int16 htcisvalid2=0;
Int16 htcisvalidh=0;



System.IntPtr vup_hwnd;

public static float GSCALE=10; // scale factor between vup and Unity App

int phase=0; // connection stat between vup and Unity: 0=connecting, 1=downloading, 2-------------------------=download complete
int prc; // download pgrogress between 0 and 100

// for exchanges bet0ween vup and Unity App
byte [] buffer; 
byte [] sbuffer; 

// for dynamic texture exchanges from vup to Unity App
uint lsurfacebytes;
IntPtr surfacebytes;
int _dyntexcount=0;
int _dyntexphase=0;

// for color exchanges from vup to Unity App
UInt32 []cols;
UInt32 []lastcols;
float []alphas;


// connect to vup
// return 0 if ok,7 <0 otherwise
// return numver of vup sprites 3d and resources directory
int vup_vcom_connect(ref int nsp,ref string prpdir)
{
vup_hwnd = FindWindow("vu_communication", null);
if(vup_hwnd==null)
    {
    return -1; // vup not launched
    }
int Z=vupdll_init(vup_hwnd);
if(Z!=1234)
	{
	return -2; // vup cannot initialize communication
	}
System.IntPtr LPARAM;
LPARAM=(System.IntPtr)1234; // signature
if(SendMessage(vup_hwnd,0x400/*WM_USER*/+0x1241,System.IntPtr.Zero,LPARAM)!=0x4112)
	{
	return -3; // vup initialization failed
	}
nsp=SendMessage(vup_hwnd,0x400/*WM_USER*/+0x1243,System.IntPtr.Zero,System.IntPtr.Zero);
ushort atom=(ushort)SendMessage(vup_hwnd,0x400/*WM_USER*/+0x1244,System.IntPtr.Zero,System.IntPtr.Zero);
if(atom==0)
	{
	return -4; // vup initialization failed : can't get resources directory
	}
int nSize = 1024;
StringBuilder AtomName = new System.Text.StringBuilder(nSize);
GlobalGetAtomName(atom,AtomName,nSize);
prpdir=AtomName.ToString();
GlobalDeleteAtom(atom);
return 0;
}


vupobj vo;


// Unity object to be the parent of the vup objects
public GameObject master;

// Load vup objects
IEnumerator loadsprites3d(object[] parms)
		{
		int NOBJ=(int)parms[0];
		string prpdir=(string)parms[1];
		_selectable=new Int16[NOBJ];
		_pickable=new Int16[NOBJ];
		_notselectable=new int[NOBJ];
		_isvisible=new int[NOBJ];
        scxs=new double[NOBJ];
        scys=new double[NOBJ];
        sczs=new double[NOBJ];
        PG=new GameObject[NOBJ];
		BC=new MeshCollider[NOBJ];
        G=new GameObject[NOBJ];
		_t2ds=new Texture2D[NOBJ];
		_dyntex=new int[NOBJ];
		_notfirstdyntex=new int[NOBJ];
		_childof=new int[NOBJ];
		_orichildof=new int[NOBJ];
        int CO;
		GameObject[] allObjects = GameObject.FindObjectsOfType<GameObject>();
		int i;
		// search for the master object "vup"
		// if not found, create it
		for(i=0;i<allObjects.Length;i++)
			{
			GameObject gameObject=(GameObject)allObjects.GetValue(i);
			vo=gameObject.GetComponent<vupobj>();
			if(vo!=null)
				{
				if(vo.num==-1)
					{ 
					master=allObjects[ i ];
					break;
					}			 
				}
			}
		if(i==allObjects.Length)
			{
			master=new GameObject("vup");
			}

        for(CO=0;CO<NOBJ;CO++)
            {
			_selectable[CO]=0;
			_pickable[CO]=0;
			_notselectable[CO]=0;
			_isvisible[CO]=2;
			prc=(int)((float)CO*100)/NOBJ;
			// check if object exists, if no, download it from vup
			string id="(vup#";
			id+=CO.ToString()+")";
			for(i=0;i<allObjects.Length;i++)
				{ 
				GameObject gameObject=(GameObject)allObjects.GetValue(i);
				vo=gameObject.GetComponent<vupobj>();
				if(vo!=null)
					{
					if(vo.num==CO)
						{ 
						if(vo.aorb==1)
							{
							break;
							}	
						}
					}
				}
			if(i<allObjects.Length)
				{
				_notfirstdyntex[CO]=0;
				_dyntex[CO]=vo.dyntex;
				G[CO]= allObjects[ i ];
				PG[CO]=G[CO].transform.parent.gameObject;
				int CC,NC=G[CO].transform.childCount;
				for(CC=0;CC<NC;CC++)
					{
					GameObject meshlevel=G[CO].transform.GetChild(CC).gameObject;
					if(meshlevel)
						{ 
						MeshFilter MF=meshlevel.GetComponent<MeshFilter>();
						if(MF)
							{ 
							Mesh mesh = MF.mesh;
							if(mesh)	
								{ 
								meshlevel.AddComponent<MeshCollider>().sharedMesh=mesh;
								}
							}
						}
					}
				G[CO].layer=_notselectable[CO]==0?8:9;
				}
			if(G[CO]==null)
                { 
                string STR;
                STR=string.Format("{0}\\meshes\\{1}.obj",prpdir,CO);
                 try  
                    {  
					uint gid1=0,gid2=0;
					int dyntex=-1;
					int childof=-1;
					double scx=1,scy=1,scz=1;
					string vupname="";
					_dyntex[CO]=-1;
					_notfirstdyntex[CO]=0;
                    G[CO]=OBJLoader.LoadOBJFile(STR,ref childof,ref vupname,ref dyntex,ref _notselectable[CO],ref gid1,ref gid2,ref scx,ref scy,ref scz);
					scxs[CO]=scx;
					scys[CO]=scy;
					sczs[CO]=scz;
					G[CO].AddComponent<vupobj>();
					G[CO].GetComponent<vupobj>().num=CO;
					G[CO].GetComponent<vupobj>().gd1=gid1;
					G[CO].GetComponent<vupobj>().gd2=gid2;
					int CC,NC=G[CO].transform.childCount;

					for(CC=0;CC<NC;CC++)
						{
						GameObject meshlevel=G[CO].transform.GetChild(CC).gameObject;
						if(meshlevel)
							{ 
							MeshFilter MF=meshlevel.GetComponent<MeshFilter>();
							if(MF)
								{ 
								Mesh mesh = MF.mesh;
								if(mesh)	
									{ 
									meshlevel.AddComponent<MeshCollider>().sharedMesh=mesh;
									}
								}
							}
						}
					G[CO].layer=_notselectable[CO]==0?8:9;
					vupname=id+vupname;
					G[CO].name=vupname+".b";
					G[CO].SetActive(false);
					string name;
					name="p";
					name=vupname+".a";
					PG[CO]=new GameObject(name);
					PG[CO].layer=8;
					G[CO].transform.SetParent(PG[CO].transform);
					if(childof>=0)
						{
						PG[CO].transform.SetParent(G[childof].transform);
						}
					else
						{
						PG[CO].transform.SetParent(master.transform);
						}
					_dyntex[CO]=dyntex;
					_notfirstdyntex[CO]=0;
					_childof[CO]=childof;
					_orichildof[CO]=childof;
					}
				catch (System.Exception e)
					{
					Debug.LogException(e, this);                    
                    }
				}
			yield return null;
			}
		for(CO=0;CO<NOBJ;CO++)
			{ 
			if(G[CO]) G[CO].SetActive(true);
			}
		_nobjs=NOBJ;
		phase=2;
		yield return null;
		}

// close connection between vup and Unity App
void vup_vcom_unconnect()
{
if(vup_hwnd!=null)
	{
	PostMessage(vup_hwnd,0x400/*WM_USER*/+0x1242,System.IntPtr.Zero,System.IntPtr.Zero);
	vup_hwnd=System.IntPtr.Zero;
	}
}

public string twodirup2(string d)
{
string r=d;
int pos=r.LastIndexOf("\\");
if(pos>0)
	{
	r=r.Substring(0,pos);
	}
return r;
}

public string twodirup(string d)
{
string r=d;
int pos=r.LastIndexOf("/");
if(pos>0)
	{
	r=r.Substring(0,pos);
	}
pos=r.LastIndexOf("/");
if(pos>0)
	{
	r=r.Substring(0,pos);
	}
return r;
}

	int _nobjs;
	GameObject []G;
	double []scxs;
	double []scys;
	double []sczs;
	GameObject []PG;
	MeshCollider []BC;

	Texture2D []_t2ds;
	int []_dyntex;
	int []_notfirstdyntex;
	int []_childof;
	int []_orichildof;
	Int16 []_selectable;
	Int16 []_pickable;
	int []_notselectable;
	int []_isvisible;
	int colorid;


	void Start () 
	{

	colorid=Shader.PropertyToID("_Color");
	cols=new UInt32[128];
	alphas=new float[128];
	pickedforce=new float[3];
	htcpos1=new float[16];
	htcpos2=new float[16];
	htcvel1=new float[6];
	htcvel2=new float[6];
	htcposh=new float[16];
	htcvelh=new float[6];
	Application.runInBackground = true;
	buffer=new byte[0x800000];
	sbuffer=new byte[0x1000];
	string prpdir="";
	int NOBJ=0;
	// connecting to vup
	if(vup_vcom_connect(ref NOBJ,ref prpdir)==0)
		{ 
		// ok, connected: loading objects from vup
		phase=1;
		int NOBJParameter = NOBJ;
        string prpdirParameter = prpdir;
        object[] parms = new object[2]{NOBJParameter, prpdirParameter};
        StartCoroutine("loadsprites3d", parms);
		}
	lastcols=new UInt32[NOBJ*128];
	}
	
	int ncall;


	// fast conversions
	
	public static unsafe int toint32(byte[] numRef, int startIndex)
	{
	fixed (byte * p = &numRef[startIndex])
	return * ((int *) p);
	}

	public static unsafe uint touint32(byte[] numRef, int startIndex)
	{
	fixed (byte * p = &numRef[startIndex])
	return * ((uint *) p);
	}


	public static unsafe Int16 toint16(byte[] numRef, int startIndex)
	{
	fixed (byte * p = &numRef[startIndex])
	return * ((Int16 *) p);
	}

	public static unsafe UInt16 touint16(byte[] numRef, int startIndex)
	{
	fixed (byte * p = &numRef[startIndex])
	return * ((UInt16 *) p);
	}



	public static unsafe float tosingle(byte[] numRef, int startIndex)
	{
	fixed (byte * p = &numRef[startIndex])
	return * ((float *) p);
	}



	int _lastt=0;
	int _lastt2=0;

	
	void Update () {
		
	
	
	// picking, clicking and mouse over management
	if(prepicked!=-1)
		{
		float dx=prepickedpos.x-Input.mousePosition.x;
		float dy=prepickedpos.y-Input.mousePosition.y;
		if(dx<-5||dx>5||dy<-5||dy>5)
			{
			picked=prepicked;
			prepicked=-1;
			}
		}
	if(picked!=-1)
		{
		Vector3 diffobj=G[picked].transform.position-firstpickedobjpos;
		Vector3 v=Camera.main.ScreenToWorldPoint(new Vector3(Input.mousePosition.x,Input.mousePosition.y,firstpickeddistance));
		Vector3 diffpick=v-firstpickedpos;
		diffpick-=diffobj;
		pickedforce[0]=diffpick.x*4;
		pickedforce[1]=diffpick.y*4;
		pickedforce[2]=diffpick.z*4;
		}

	if(Input.GetMouseButtonUp(0))
		{
		clicked=-1;
		picked=-1;
		prepicked=-1;
		pickedforce[0]=0;
		pickedforce[1]=0;
		pickedforce[2]=0;
		}
	else
		{
		if (vr==0&&Input.GetMouseButtonDown(0)) 
			{
			RaycastHit[]  hits;
	        Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
			hits=Physics.RaycastAll(ray,100,1<<8);
		    int CC,LL=hits.GetLength(0);
			// Sort depending distance
			for(CC=0;CC<LL-1;CC++)
				{
				if(hits[CC].distance>hits[CC+1].distance)
					{
					RaycastHit H;
					H=hits[CC];
					hits[CC]=hits[CC+1];
					hits[CC+1]=H;
					CC=-1;
					}
				}
			for(CC=0;CC<LL;CC++)
				{
				if(hits[CC].transform.parent.GetComponent<vupobj>())
					{ 
					int num=hits[CC].transform.parent.GetComponent<vupobj>().num;
					if((clicked==-1||_dyntex[num]!=-1)&&_selectable[num]!=0) // Priority to dynamic textures for clicks
						{
						clicked=num;
						}
					if(prepicked==-1&&_pickable[num]!=0)
						{
						if(prepicked==-1)
							{ 
							firstpickedpos=hits[CC].point;
							firstpickeddistance=hits[CC].distance;
							firstpickedobjpos=G[num].transform.position;
							prepicked=num;
							prepickedpos=Input.mousePosition;
							}
						}
					float D=hits[CC].distance;
					RayP0=ray.GetPoint(D-(float)100);
					RayP1=ray.GetPoint(D+(float)100);
					P0=RayP0;
					P1=RayP1;
					RayP0.x*=GSCALE;
					RayP0.y*=GSCALE;
					RayP0.z*=GSCALE;
					RayP1.x*=GSCALE;
					RayP1.y*=GSCALE;
					RayP1.z*=GSCALE;
					}
				}
			}
		else
			{
			if(vr==0&&Camera.main)
				{ 
		        RaycastHit  hit;
			    Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
				if (Physics.Raycast(ray, out hit,100,1<<8)) 
					{
					if(hit.transform.parent.GetComponent<vupobj>())
						{ 
						mouseover=hit.transform.parent.GetComponent<vupobj>().num;
						float D=hit.distance;
						RayP0=ray.GetPoint(D-(float)100);
						RayP0.x*=GSCALE;
						RayP0.y*=GSCALE;
						RayP0.z*=GSCALE;
						RayP1=ray.GetPoint(D+(float)100);
						RayP1.x*=GSCALE;
						RayP1.y*=GSCALE;
						RayP1.z*=GSCALE;
						}
					}
				else
					{
					mouseover=-1;
					}
				}
			else
				{
				mouseover=-1;
				}
			}
		}

	if(phase==2&&vup_hwnd!=System.IntPtr.Zero)
		{ 
		if(System.Environment.TickCount-_lastt>10)
			{ 
			_lastt=System.Environment.TickCount;
/* delete this line to use SteamVr
	if(vr==1)
		{ // compute vr informations to be sent to vup
		htcisvalidh=0;
		if(xrhead!=null)
			{
			xrch= SteamVR_Controller.Input((int)xrhead.index);
			Valve.VR.TrackedDevicePose_t VrPos=xrch.GetPose();
			float TX,TY,TZ;
			TX=xrhead.transform.position.x*GSCALE;
			TY=xrhead.transform.position.y*GSCALE;
			TZ=xrhead.transform.position.z*GSCALE;
			Matrix4x4 MAT;
			MAT=Matrix4x4.identity;
			MAT[3,0]=TX;
			MAT[3,1]=TY;
			MAT[3,2]=TZ;
			MAT[3,3]=1.0f;
			// Quaternion->matrix
			float []q;
			q=new float[4];
			Quaternion Q=xrhead.transform.rotation;	
			q[0]=Q.x;
			q[1]=Q.y;
			q[2]=Q.z;
			q[3]=Q.w;

			MAT[0,0]=1.0f - 2.0f * (q[1] * q[1] + q[2] * q[2]);
			MAT[0,1] = 2.0f * (q[0] * q[1] + q[2] * q[3]);
			MAT[0,2] = 2.0f * (q[0] * q[2] - q[1] * q[3]);
			MAT[1,0] = 2.0f * (q[0] * q[1] - q[2] * q[3]);
			MAT[1,1] = 1.0f - 2.0f * (q[0] * q[0] + q[2] * q[2]);
			MAT[1,2] = 2.0f * (q[1] * q[2] + q[0] * q[3]);
			MAT[2,0] = 2.0f * (q[0] * q[2] + q[1] * q[3]);
			MAT[2,1] = 2.0f * (q[1] * q[2] - q[0] * q[3]);
			MAT[2,2] = 1.0f - 2.0f * (q[0] * q[0] + q[1] * q[1]);
			htcposh[0]=MAT.m00;
			htcposh[1]=MAT.m01;
			htcposh[2]=MAT.m02;
			htcposh[3]=MAT.m03;
			htcposh[4]=MAT.m10;
			htcposh[5]=MAT.m11;
			htcposh[6]=MAT.m12;
			htcposh[7]=MAT.m13;
			htcposh[8]=MAT.m20;
			htcposh[9]=MAT.m21;
			htcposh[10]=MAT.m22;
			htcposh[11]=MAT.m23;
			htcposh[12]=MAT.m30;
			htcposh[13]=MAT.m31;
			htcposh[14]=MAT.m32;
			htcposh[15]=MAT.m33;
			htcvelh[0]=VrPos.vVelocity.v0/100;
			htcvelh[1]=VrPos.vVelocity.v1/100;
			htcvelh[2]=VrPos.vVelocity.v2/100;
			htcvelh[3]=VrPos.vAngularVelocity.v0;
			htcvelh[4]=VrPos.vAngularVelocity.v1;
			htcvelh[5]=VrPos.vAngularVelocity.v2;
			htcisvalidh=1;
			}
		htcisvalid1=0;
		if(xrstc1!=null)
			{ 
			xrc1= SteamVR_Controller.Input((int)xrstc1.controllerIndex);
			if(xrc1.connected)
			{ 
			htcbutton1=xrstc1.controllerState.ulButtonPressed;
			htctrigger1=xrstc1.controllerState.rAxis1.x;
			Valve.VR.TrackedDevicePose_t VrPos=xrc1.GetPose();
			float TX,TY,TZ;
			TX=xrstc1.transform.position.x*GSCALE;
			TY=xrstc1.transform.position.y*GSCALE;
			TZ=xrstc1.transform.position.z*GSCALE;
			Matrix4x4 MAT;
			MAT=Matrix4x4.identity;
			MAT[3,0]=TX;
			MAT[3,1]=TY;
			MAT[3,2]=TZ;
			MAT[3,3]=1.0f;
			// Quaternion->matrix
			float []q;
			q=new float[4];
			Quaternion Q=xrstc1.transform.rotation;//,QR;	
			q[0]=Q.x;
			q[1]=Q.y;
			q[2]=Q.z;
			q[3]=Q.w;

			MAT[0,0]=1.0f - 2.0f * (q[1] * q[1] + q[2] * q[2]);
			MAT[0,1] = 2.0f * (q[0] * q[1] + q[2] * q[3]);
			MAT[0,2] = 2.0f * (q[0] * q[2] - q[1] * q[3]);
			MAT[1,0] = 2.0f * (q[0] * q[1] - q[2] * q[3]);
			MAT[1,1] = 1.0f - 2.0f * (q[0] * q[0] + q[2] * q[2]);
			MAT[1,2] = 2.0f * (q[1] * q[2] + q[0] * q[3]);
			MAT[2,0] = 2.0f * (q[0] * q[2] + q[1] * q[3]);
			MAT[2,1] = 2.0f * (q[1] * q[2] - q[0] * q[3]);
			MAT[2,2] = 1.0f - 2.0f * (q[0] * q[0] + q[1] * q[1]);
			htcpos1[0]=MAT.m00;
			htcpos1[1]=MAT.m01;
			htcpos1[2]=MAT.m02;
			htcpos1[3]=MAT.m03;
			htcpos1[4]=MAT.m10;
			htcpos1[5]=MAT.m11;
			htcpos1[6]=MAT.m12;
			htcpos1[7]=MAT.m13;
			htcpos1[8]=MAT.m20;
			htcpos1[9]=MAT.m21;
			htcpos1[10]=MAT.m22;
			htcpos1[11]=MAT.m23;
			htcpos1[12]=MAT.m30;
			htcpos1[13]=MAT.m31;
			htcpos1[14]=MAT.m32;
			htcpos1[15]=MAT.m33;
			htcvel1[0]=VrPos.vVelocity.v0/100;
			htcvel1[1]=VrPos.vVelocity.v1/100;
			htcvel1[2]=VrPos.vVelocity.v2/100;
			htcvel1[3]=VrPos.vAngularVelocity.v0;
			htcvel1[4]=VrPos.vAngularVelocity.v1;
			htcvel1[5]=VrPos.vAngularVelocity.v2;
			htcisvalid1=1;
			}
			}
		htcisvalid2=0;
		if(xrstc2!=null)
			{ 
			xrc2= SteamVR_Controller.Input((int)xrstc2.controllerIndex);
			if(xrc2.connected)
			{
			htcbutton2=xrstc2.controllerState.ulButtonPressed;
			htctrigger2=xrstc2.controllerState.rAxis1.x;
			Valve.VR.TrackedDevicePose_t VrPos=xrc2.GetPose();

			float TX,TY,TZ;
			TX=xrstc2.transform.position.x*GSCALE;
			TY=xrstc2.transform.position.y*GSCALE;
			TZ=xrstc2.transform.position.z*GSCALE;
			Matrix4x4 MAT;
			MAT=Matrix4x4.identity;
			MAT[3,0]=TX;
			MAT[3,1]=TY;
			MAT[3,2]=TZ;
			MAT[3,3]=1.0f;
			// Quaternion->matrix
			float []q;
			q=new float[4];

			Quaternion Q=xrstc2.transform.rotation;	
			q[0]=Q.x;
			q[1]=Q.y;
			q[2]=Q.z;
			q[3]=Q.w;

			MAT[0,0]=1.0f - 2.0f * (q[1] * q[1] + q[2] * q[2]);
			MAT[0,1] = 2.0f * (q[0] * q[1] + q[2] * q[3]);
			MAT[0,2] = 2.0f * (q[0] * q[2] - q[1] * q[3]);
			MAT[1,0] = 2.0f * (q[0] * q[1] - q[2] * q[3]);
			MAT[1,1] = 1.0f - 2.0f * (q[0] * q[0] + q[2] * q[2]);
			MAT[1,2] = 2.0f * (q[1] * q[2] + q[0] * q[3]);
			MAT[2,0] = 2.0f * (q[0] * q[2] + q[1] * q[3]);
			MAT[2,1] = 2.0f * (q[1] * q[2] - q[0] * q[3]);
			MAT[2,2] = 1.0f - 2.0f * (q[0] * q[0] + q[1] * q[1]);
			htcpos2[0]=MAT.m00;
			htcpos2[1]=MAT.m01;
			htcpos2[2]=MAT.m02;
			htcpos2[3]=MAT.m03;
			htcpos2[4]=MAT.m10;
			htcpos2[5]=MAT.m11;
			htcpos2[6]=MAT.m12;
			htcpos2[7]=MAT.m13;
			htcpos2[8]=MAT.m20;
			htcpos2[9]=MAT.m21;
			htcpos2[10]=MAT.m22;
			htcpos2[11]=MAT.m23;
			htcpos2[12]=MAT.m30;
			htcpos2[13]=MAT.m31;
			htcpos2[14]=MAT.m32;
			htcpos2[15]=MAT.m33;
			htcvel2[0]=VrPos.vVelocity.v0/100;
			htcvel2[1]=VrPos.vVelocity.v1/100;
			htcvel2[2]=VrPos.vVelocity.v2/100;
			htcvel2[3]=VrPos.vAngularVelocity.v0;
			htcvel2[4]=VrPos.vAngularVelocity.v1;
			htcvel2[5]=VrPos.vAngularVelocity.v2;
			htcisvalid2=1;
			}
			}

		}	
delete this line to use SteamVr */	
		// prepare datas to be sent to vup
		int spos=0;
		byte[] b = BitConverter.GetBytes(clicked);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(picked);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(mouseover);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		int rank;
		for(rank=0;rank<16;rank++)
			{
			b = BitConverter.GetBytes(htcpos1[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}
		for(rank=0;rank<6;rank++)
			{
			b = BitConverter.GetBytes(htcvel1[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}
		b = BitConverter.GetBytes(htcbutton1);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(htctrigger1);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(htcisvalid1);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		for(rank=0;rank<16;rank++)
			{
			b = BitConverter.GetBytes(htcpos2[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}
		for(rank=0;rank<6;rank++)
			{
			b = BitConverter.GetBytes(htcvel2[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}
		b = BitConverter.GetBytes(htcbutton2);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(htctrigger2);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(htcisvalid2);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		for(rank=0;rank<16;rank++)
			{
			b = BitConverter.GetBytes(htcposh[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}
		for(rank=0;rank<6;rank++)
			{
			b = BitConverter.GetBytes(htcvelh[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}
		b = BitConverter.GetBytes(htcisvalidh);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		for(rank=0;rank<3;rank++)
			{
			b = BitConverter.GetBytes(pickedforce[rank]);
			b.CopyTo(sbuffer, spos);
			spos += b.Length;
			}


		b = BitConverter.GetBytes(RayP0.x);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(RayP0.y);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(RayP0.z);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		b = BitConverter.GetBytes(RayP1.x);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(RayP1.y);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;
		b = BitConverter.GetBytes(RayP1.z);
		b.CopyTo(sbuffer, spos);
		spos += b.Length;

		// send datas to vup and get datas from vup
		int len=vupdll_com(sbuffer,buffer);
		
		if(len>0)
			{ // datas received from vup
			int pos=0;
			int slen=toint32(buffer,pos+4);
			
			uint nchangedsprite3d=touint32(buffer,pos+12); // get number of 3d sprite for which datas have changed

			uint c;
			pos+=slen-4;
			for(c=0;c<nchangedsprite3d;c++) // for all of these 3d sprites
				{
				int slen2=toint32(buffer,pos);
				int pos2=pos+4;
				uint num=touint32(buffer,pos2);
				pos2+=4;
				uint obj=num&0x7fffffff; // vup object number
				bool tchanged=false,rchanged=false,schanged=false;
				float x=0,y=0,z=0;
				float rx=0,ry=0,rz=0;
				float qx=0,qy=0,qz=0,qw=0;
				float arx=0,ary=0,arz=0;
				float sx=1,sy=1,sz=1;
				Int16 visible=0;
				Int16 selectable=0;
				Int16 pickable=0;
				Int16 usetextmat=0;
				float texoffsetx=0;
				float texoffsety=0;
				Int32 childof=-1;
				if((num&0x80000000)!=0) // optimized datas : only modified datas
					{
					ushort changed1=touint16(buffer,pos2);
					if((changed1&1)!=0)
						{ 
						tchanged=true;
						x=-tosingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&2)!=0)
						{ 
						tchanged=true;
						y=tosingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&4)!=0)
						{ 
						tchanged=true;
						z=tosingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&8)!=0)
						{ 
						rchanged=true;
						rx=tosingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&0x10)!=0)
						{ 
						rchanged=true;
						ry=tosingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&0x20)!=0)
						{ 
						rchanged=true;
						rz=-tosingle(buffer,pos2);
						pos2+=4;
						}
					if((changed1&0x40)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x80)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x100)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x200)!=0)
						{
						int posmchange=pos2;
						pos2+=128/4;
						Int32 CM;
						for(CM=0;CM<128;CM++)
							{
							if((buffer[posmchange+CM/8]&(1<<(CM&7)))!=0)
								{
								pos2+=4;
								}
							}
						}
					if((changed1&0x400)!=0)
						{
						visible=toint16(buffer,pos2);
						pos2+=2;
						}
					if((changed1&0x800)!=0)
						{
						selectable=toint16(buffer,pos2);	
						pos2+=2;
						}
					if((changed1&0x1000)!=0)
						{
						pickable=toint16(buffer,pos2);
						pos2+=2;
						}
					if((changed1&0x2000)!=0)
						{
						ushort um=touint16(buffer,pos2);
						pos2+=2;
						if(um!=0)
							{
							pos2+=8;
							}
						else
							{
							texoffsetx=tosingle(buffer,pos2);
							pos2+=4;
							texoffsety=tosingle(buffer,pos2);
							pos2+=4;
							}
						}
					if((changed1&0x4000)!=0)
						{
						schanged=true;
						sx=tosingle(buffer,pos2);
						pos2+=4;
						sy=tosingle(buffer,pos2);
						pos2+=4;
						sz=tosingle(buffer,pos2);
						pos2+=4;
						}
					}
				else
					{ // non optimized datas
					tchanged=true;
					rchanged=true;
					x=-tosingle(buffer,pos2);
					pos2+=4;
					y=tosingle(buffer,pos2);
					pos2+=4;
					z=tosingle(buffer,pos2);
					pos2+=4;
					rx=tosingle(buffer,pos2);
					pos2+=4;
					ry=tosingle(buffer,pos2);
					pos2+=4;
					rz=-tosingle(buffer,pos2);
					pos2+=4;
					qx=tosingle(buffer,pos2);
					pos2+=4;
					qy=tosingle(buffer,pos2);
					pos2+=4;
					qz-=tosingle(buffer,pos2);
					pos2+=4;
					qw-=tosingle(buffer,pos2);
					pos2+=4;
					arx=-tosingle(buffer,pos2);
					pos2+=4;
					ary=tosingle(buffer,pos2);
					pos2+=4;
					arz=tosingle(buffer,pos2);
					pos2+=4;
					if(slen2>=2140) // datas include scale
						{
						schanged=true;
						sx=tosingle(buffer,pos2);
						pos2+=4;
						sy=tosingle(buffer,pos2);
						pos2+=4;
						sz=tosingle(buffer,pos2);
						pos2+=4;
						}
					childof=toint32(buffer,pos2);
					pos2+=4;
					visible=toint16(buffer,pos2);
					pos2+=2;
					selectable=toint16(buffer,pos2);
					pos2+=2;
					pickable=toint16(buffer,pos2);
					pos2+=2;
					// metalness
					pos2+=128*4;
					// roughness
					pos2+=128*4;
					// alpha
					int _rank;
					for(_rank=0;_rank<128;_rank++)
						{ 
						alphas[_rank]=tosingle(buffer,pos2);
						pos2+=4;
						}
					// col
					for(_rank=0;_rank<128;_rank++)
						{ 
						cols[_rank]=touint32(buffer,pos2);
						pos2+=4;
						}
					usetextmat=toint16(buffer,pos2);
					pos2+=2;
					texoffsetx=tosingle(buffer,pos2);
					pos2+=4;
					texoffsety=tosingle(buffer,pos2);
					pos2+=4;
					pos+=slen2;
					}
				if(G[obj]!=null) 
					{ 
					// apply received datas to object
					_selectable[obj]=selectable;
					_pickable[obj]=pickable;
					MeshRenderer rend=G[obj].GetComponentInChildren<MeshRenderer>();
					int CMAT,NMAT=rend.materials.Length;
					if(NMAT>128) NMAT=128;
					for(CMAT=0;CMAT<NMAT;CMAT++)
						{
						if(cols[CMAT]!=lastcols[obj*128+CMAT])
							{ 
							UInt32 __R=cols[CMAT];
							__R&=255;
							UInt32 __G=cols[CMAT];
							__G&=0xff00;
							__G>>=8;
							UInt32 __B=cols[CMAT];
							__B&=0xff0000;
							__B>>=16;
							float _r,_g,_b,_a;
							_r=__R;
							_r/=255;
							_g=__G;
							_g/=255;
							_b=__B;
							_b/=255;
							_a=1-alphas[CMAT];
							Color COL=new Color(_r,_g,_b,_a);
							if(rend.materials[CMAT].name[0]!='$') rend.materials[CMAT].SetColor(colorid,COL); // Ne pas écraser les couleurs définies dans vurt
							lastcols[obj*128+CMAT]=cols[CMAT];
							}
						}

					if(_childof[obj]!=childof)
						{
						if(childof==-1)
							{
							PG[obj].transform.parent=master.transform;
							}
						else
							{ 
							PG[obj].transform.SetParent(G[childof].transform,true);
							}
						_childof[obj]=childof;
						}
					if(childof!=_orichildof[obj])
						{
						// parent object is not the same tham when startup
						qx=-qx;
						qy=-qy;
						qz=-qz;
						qw=-qw;
						tchanged=true;
						rchanged=true;
						}
					if((visible&1)!=0)
						{ 
						if(_isvisible[obj]!=1)
							{ // object become visible
							_isvisible[obj]=1;
							int CC;
							MeshRenderer []R=G[obj].GetComponentsInChildren<MeshRenderer>();
							for(CC=0;CC<R.Length;CC++)
								{ 
								R[CC].enabled=true;
								}
							MeshCollider []MC=G[obj].GetComponentsInChildren<MeshCollider>();
							for(CC=0;CC<MC.Length;CC++)
								{ 
								MC[CC].enabled=true;
								}
							G[obj].layer=_notselectable[obj]==0?8:9;
							}
						}
					else
						{ 
						if(_isvisible[obj]!=0)
							{ // object become visible
							_isvisible[obj]=0;
							int CC;
							MeshRenderer []R=G[obj].GetComponentsInChildren<MeshRenderer>();
							for(CC=0;CC<R.Length;CC++)
								{ 
								R[CC].enabled=false;
								}
							MeshCollider []MC=G[obj].GetComponentsInChildren<MeshCollider>();
							for(CC=0;CC<MC.Length;CC++)
								{ 
								MC[CC].enabled=false;
								}
							G[obj].layer=10;
							}
						}
					// dynamic texture offsets
					if(usetextmat!=0)
						{
						MeshRenderer R=G[obj].GetComponentInChildren<MeshRenderer>();
						R.material.SetTextureOffset("_MainTex", new Vector2(texoffsetx,texoffsety));
						}
					if(schanged)
						{ // scale has changed
						Vector3 curscale=G[obj].transform.localScale;
						float _sx,_sy,_sz;
						if(scxs[obj]==0) _sx=1;
						else _sx=sx/(float)scxs[obj];
						if(scys[obj]==0) _sy=1;
						else _sy=sy/(float)scys[obj];
						if(sczs[obj]==0) _sz=1;
						else _sz=sz/(float)sczs[obj];
						if(curscale.x!=_sx||curscale.y!=_sy||curscale.z!=_sz)
							{
							G[obj].transform.localScale=new Vector3(_sx,_sy,_sz);
							}
						}
					if(tchanged||rchanged) 
						{ // position or rotation has changed
						Quaternion Q=new Quaternion(qx,qy,-qz,qw);
						PG[obj].transform.localRotation=Q;
						PG[obj].transform.localPosition=new Vector3(x/GSCALE,y/GSCALE,z/GSCALE);
						G[obj].transform.localPosition=new Vector3(arx/GSCALE,ary/GSCALE,arz/GSCALE);
						}
					}
				}
			}
		// dynamic textures
		int CO;
		if(System.Environment.TickCount-_lastt2>100) // not to often
			{ 
			_lastt2=System.Environment.TickCount;
			if(_dyntexphase==0)
				{ 
			    for(CO=_dyntexcount;CO<_nobjs;CO++)
				    {
					if(_dyntex[CO]!=-1)
						{
						_dyntexcount=CO;
						uint SURFNUM=(uint)_dyntex[CO];
						if(_notfirstdyntex[CO]==0)
							{
							SURFNUM|=0x80000000;
							}
						int ret=vupdll_requestsurface(SURFNUM);
						_notfirstdyntex[CO]=1;
						if(ret==0x55ab)
							{ // Texture has not changed
							continue;
							}
						if(ret==0x55aa)
							{  // Texture changed
							_dyntexphase=1;
							}
						break;
						}			
					}			
				if(CO==_nobjs)
					{
					_dyntexcount=0;
					}
				}
			else
				{
				MeshRenderer R=G[_dyntexcount].GetComponentInChildren<MeshRenderer>();
				if(R)
					{
					Texture2D T2D=(Texture2D)R.material.mainTexture;
					if(T2D)
						{
						int CX=T2D.width;
						int CY=T2D.height;
						if(_t2ds[_dyntexcount]==null)
							{ 
							_t2ds[_dyntexcount]=new Texture2D(CX,CY,TextureFormat.BGRA32,false);
							if(_t2ds[_dyntexcount])
								{ 
								R.material.mainTexture=_t2ds[_dyntexcount];
								R.material.SetColor("_Color",new Color32(128,128,128,0));
								}
							}
						if(_t2ds[_dyntexcount])
							{ 
							if(surfacebytes==null||lsurfacebytes<CX*CY)
								{ 
								if(surfacebytes!=null) Marshal.FreeHGlobal(surfacebytes);
								surfacebytes=Marshal.AllocHGlobal(CX*CY*4);
								lsurfacebytes=(uint)(CX*CY);
								}
							if(surfacebytes!=null)
								{ 
								int tlen=0;
								if(surfacebytes!=null)
									{
									// get surface bytes
									tlen=vupdll_getsurface((uint)_dyntex[_dyntexcount],surfacebytes);
									}


									{
									if(tlen==CX*CY*4)
										{
										_t2ds[_dyntexcount].LoadRawTextureData(surfacebytes,tlen);
										_t2ds[_dyntexcount].Apply();
										}
									}
								}
							}
						}
					_dyntexphase=0;
					_dyntexcount++;
					}
				}
			}	
		ncall++;
		}
		}

}


 void OnDestroy() {
vupdll_uninit();        
    }



}


